//*
//*       COMPILE SAMPLE CICS TRANSACTION MAIL
//*
//* PAY ATTENTION TO THE LINK EDIT MODIFICATIONS AT THE END OF THIS
//* MEMBER.
//*
//DFHSMCEX EXEC DFHSMCEX,NAME=MAILTEST,TRNPARM=',SP'
//SYSIN     DD *
       IDENTIFICATION DIVISION.
           SKIP1
      ******************************************************************
      *                                                                *
      *        I D E N T I F I C A T I O N      D I V I S I O N        *
      *                                                                *
      ******************************************************************
           SKIP3
       PROGRAM-ID.     MAILTEST.
           SKIP1
       AUTHOR.         DONALD GRINSELL.
           SKIP1
       INSTALLATION.   STATE OF MONTANA.
           SKIP1
       DATE-WRITTEN.   JAN 11, 2000.
           SKIP1
       DATE-COMPILED.
           SKIP2
       REMARKS.        C I C S    M A I L   T R A N S A C T I O N
           SKIP1
                       THIS PROGRAM IS USED TO TEST THE 
                       SOCKETS VERSION OF THE SENDMAIL PGM.
           SKIP3
      ******************************************************************
           EJECT
       ENVIRONMENT DIVISION.
           SKIP1
      ******************************************************************
      *                                                                *
      *        E N V I R O N M E N T       D I V I S I O N             *
      *                                                                *
      ******************************************************************
           SKIP3
       CONFIGURATION SECTION.
           SKIP1
       SOURCE-COMPUTER.    IBM-370.
       OBJECT-COMPUTER.    IBM-370.
           SKIP3
      ******************************************************************
           EJECT
       DATA DIVISION.
           SKIP1
      ******************************************************************
      *                                                                *
      *                D A T A         D I V I S I O N                 *
      *                                                                *
      ******************************************************************
           SKIP3
       WORKING-STORAGE SECTION.
           SKIP1
      ******************************************************************
      *        W O R K I N G    S T O R A G E    S E C T I O N         *
      ******************************************************************
       01 GETHOSTNAME                  PIC X(16) VALUE 'GETHOSTNAME'.
       01 NAMELEN                      PIC 9(8)  BINARY VALUE 24.
       01 HOSTNAME                     PIC X(24) VALUE SPACES.
       01 ERRNO                        PIC 9(8)  BINARY.
       01 RETCODE                      PIC S9(8) BINARY.
       01 RESPONSE-CODE                PIC S9(8) BINARY.
       01 TERMINAL-MSG-LEN             PIC S9(4) BINARY.
       01 TERMINAL-MSG                 PIC X(80) VALUE SPACES.
       01 WS-MAPSET-NAME               PIC X(8)    VALUE 'MAILMAP'.
       01 WS-MAP-CONFIRM               PIC X(8)    VALUE 'CONFIRM'.
       01 WS-MAP-ERROR                 PIC X(8)    VALUE 'ERROR'.
       01 WS-ABSTIME                   PIC S9(16).
       01 WS-ERROR-FLAG                PIC X       VALUE LOW-VALUES.
       01 WS-INDEX                     PIC 9(2).
      ******************************************************************
      *                C I C S     C O N S T A N T S                   *
      ******************************************************************
           SKIP3
           COPY DFHAID.
           EJECT
           COPY DFHBMSCA.
           EJECT
      ******************************************************************
      *                C I C S     M A P S                             *
      ******************************************************************
           SKIP3
           COPY MAILMAP.
           SKIP3
      ******************************************************************
      *                S E N D M A I L   A R E A                       *
      ******************************************************************
           SKIP3
       01  SEND-MAIL-PARMS.
          05  SEND-MAIL-HEAD0.
              10  SEND-SERVER-LENGTH     PIC S9(8) BINARY.
              10  SEND-SERVER-NAME       PIC X(24).
          05  SEND-RESPONSE REDEFINES SEND-MAIL-HEAD0 PIC X.
              88  RESP-OKAY              VALUE LOW-VALUES.
              88  RESP-COMMLEN-ERROR     VALUE '1'.
              88  RESP-INITAPI-ERROR     VALUE '2'.
              88  RESP-GETHOSTID-ERROR   VALUE '3'.
              88  RESP-OBTAIN-ERROR      VALUE '4'.
              88  RESP-CONNECT-ERROR     VALUE '5'.
              88  RESP-CLOSE-ERROR       VALUE '6'.
              88  RESP-READ-ERROR        VALUE '7'.
              88  RESP-WRITE-ERROR       VALUE '8'.
              88  RESP-NOCOMM-ERROR      VALUE HIGH-VALUES.
          05  SEND-MAIL-HEAD1.
              10  SEND-RCPT              PIC X(40).
              10  SEND-REPLY1            PIC X(40).
          05  SEND-MAIL-HEAD2.
              10  SEND-TO                PIC X(80).
          05  SEND-MAIL-HEAD3.
              10  FILLER                 PIC X VALUE '"'.
              10  SEND-FROM              PIC X(20).
              10  FILLER                 PIC X VALUE '"'.
              10  FILLER                 PIC X VALUE SPACES.
              10  FILLER                 PIC X VALUE '<'.
              10  SEND-REPLY2            PIC X(40).
              10  FILLER                 PIC X VALUE '>'.
              10  FILLER                 PIC X(15) VALUE SPACES.
          05  SEND-MAIL-HEAD4.
              10  SEND-SUBJECT           PIC X(80) VALUE SPACES.
          05  SEND-MAIL-TEXT OCCURS 15 TIMES.
              10  SEND-BODY              PIC X(80).
              10  SEND-BODY-CRLF         PIC X(2) VALUE X'0D25'.
           SKIP3
      ******************************************************************
           EJECT
       LINKAGE SECTION.
           EJECT
      ******************************************************************
      *            L I N K A G E       S E C T I O N                   *
      ******************************************************************
           SKIP3
      ******************************************************************
           EJECT
       PROCEDURE DIVISION.
           SKIP1
      ******************************************************************
      *                                                                *
      *            P R O C E D U R E      D I V I S I O N              *
      *                                                                *
      ******************************************************************
           SKIP3
       0000-MAINLINE.
           SKIP1

           IF EIBAID = DFHCLEAR OR
              EIBAID = DFHPF3 OR
              EIBAID = DFHPF15 GO TO 9999-EXIT-CICS.

           IF EIBAID = DFHPF12 OR
              EIBAID = DFHPF24
                 MOVE LOW-VALUES TO MAILMAPO
                 PERFORM 5000-GETHOSTNAME
                 PERFORM 6000-BUILD-HEADER
                 PERFORM 7000-SEND-ERASE
                 GO TO 9000-RETURN-CICS.

           EXEC CICS
               RECEIVE MAP(WS-MAPSET-NAME)
                       MAPSET(WS-MAPSET-NAME)
                       INTO(MAILMAPI)
                       RESP(RESPONSE-CODE)
           END-EXEC.

           IF RESPONSE-CODE NOT = DFHRESP(NORMAL)
               MOVE LOW-VALUES TO MAILMAPO
               PERFORM 5000-GETHOSTNAME
               PERFORM 6000-BUILD-HEADER
               PERFORM 7000-SEND-ERASE
               GO TO 9000-RETURN-CICS.

      ******************************************************************
      *  HERE WE NEED TO CHECK THE LENGTH OF THE MAP INPUT FIELDS      *
      *  AT A MINIMUM MAIL-TOL, MAIL-FROML AND MAIL-SUBJECTL MUST      *
      *  BE GREATER THAN ZERO.  IF THEY ARE WE CAN SEND THE MESSAGE.   *
      *  IF THEY ARE NOT WE MUST POSITION THE CURSOR BY MOVING -1 TO   *
      *  THE APPROPRIATE L FIELD AND PERFORM SEND-OVER ROUTINE.        *
      *  OTHERWISE WE CAN GO AHEAD AND MOVE THE MAP DATA TO THE        *
      *  COMMAREA AND LINK TO SENDMAIL.                                *
      ******************************************************************
           IF MAIL-SERVERL = ZERO OR MAIL-SERVERI = SPACES THEN
               MOVE HIGH-VALUES TO WS-ERROR-FLAG
               MOVE -1 TO MAIL-SERVERL.
           IF MAIL-TOL = ZERO OR MAIL-TOI = SPACES THEN
               MOVE HIGH-VALUES TO WS-ERROR-FLAG
               MOVE -1 TO MAIL-TOL.
           IF MAIL-REPLYL = ZERO OR MAIL-REPLYI = SPACES THEN
               MOVE HIGH-VALUES TO WS-ERROR-FLAG
               MOVE -1 TO MAIL-REPLYL.
           IF MAIL-FROML = ZERO OR MAIL-FROMI = SPACES THEN
               MOVE HIGH-VALUES TO WS-ERROR-FLAG
               MOVE -1 TO MAIL-FROML.
           IF MAIL-SUBJECTL = ZERO OR MAIL-SUBJECTI = SPACES THEN
               MOVE HIGH-VALUES TO WS-ERROR-FLAG
               MOVE -1 TO MAIL-SUBJECTL.
           IF WS-ERROR-FLAG = HIGH-VALUES THEN
               PERFORM 5000-GETHOSTNAME
               PERFORM 6000-BUILD-HEADER
               PERFORM 7500-SEND-OVER
               GO TO 9000-RETURN-CICS.
           IF EIBAID = DFHPF9 OR EIBAID = DFHPF21 THEN
               PERFORM 4000-SEND-MAIL
               IF RESP-OKAY THEN
                   PERFORM 7700-SEND-CONFIRM
                   GO TO 9000-RETURN-CICS
                   ELSE
                   PERFORM 8000-DUMP-TASK
                   PERFORM 7800-SEND-ERROR
                   GO TO 9000-RETURN-CICS
               ELSE
               PERFORM 6000-BUILD-HEADER
               MOVE -1 TO MAIL-BODYL(1)
               PERFORM 7500-SEND-OVER
               GO TO 9000-RETURN-CICS.

       4000-SEND-MAIL.

           MOVE MAIL-SERVERI TO SEND-SERVER-NAME.
           INSPECT SEND-SERVER-NAME TALLYING SEND-SERVER-LENGTH
               FOR CHARACTERS BEFORE SPACE.
           MOVE MAIL-TOI TO SEND-RCPT SEND-TO.
           MOVE MAIL-REPLYI TO SEND-REPLY1 SEND-REPLY2.
           MOVE MAIL-FROMI TO SEND-FROM.
           MOVE MAIL-SUBJECTI TO SEND-SUBJECT.
           PERFORM 4000-MOVE-BODY VARYING WS-INDEX FROM 1 BY 1
               UNTIL WS-INDEX IS GREATER THAN 15.
           EXEC CICS LINK PROGRAM('SENDMAIL')
               COMMAREA(SEND-MAIL-PARMS)
               END-EXEC.

       4000-MOVE-BODY.

           MOVE MAIL-BODYI(WS-INDEX) TO SEND-BODY(WS-INDEX).

       5000-GETHOSTNAME.

      * I CHOSE TO ISSUE A GETHOSTNAME CALL HERE TO PRIME THE SERVER
      * NAME IN THE MAP.  THERE IS NO REASON TO DO SO.  IF YOU WISH TO
      * RESTRICT YOUR USERS TO A KNOWN MAIL SERVER, HARDCODE THE 
      * SERVER NAME BELOW AND DO NOT MODIFY THE MAP ATTRIBUTE BYTE.
      * IF YOU CHOOSE TO HARDCODE THE SERVER OR ALLOW YOUR USER TO 
      * ENTER IT THEMSELVES, REALIZE THAT YOU DO NOT HAVE TO USE THE
      * LOCAL MVS SMTP SERVER.  ANY SERVER ACCESSABLE ON YOUR NETWORK
      * WILL WORK HERE.

           MOVE DFHBMFSE TO MAIL-SERVERA.
      *    MOVE 'YOUR.SMTP.SERVER' TO MAIL-SERVERO.
           CALL 'EZASOKET' USING GETHOSTNAME NAMELEN MAIL-SERVERO
                           ERRNO RETCODE.

       6000-BUILD-HEADER.

           EXEC CICS    ASSIGN
                        APPLID(MAIL-APPLIDO)
                        USERID(MAIL-USERIDO)
                        USERNAME(MAIL-FROMO)
                        END-EXEC.

           EXEC CICS    ASKTIME
                            ABSTIME    (WS-ABSTIME)
                        END-EXEC.

           EXEC CICS    FORMATTIME
                            ABSTIME    (WS-ABSTIME)
                            MMDDYYYY   (MAIL-DATEO)
                            DATESEP
                            TIME       (MAIL-TIMEO)
                            TIMESEP
                        END-EXEC.

       7000-SEND-ERASE.

           EXEC CICS    SEND
                            MAP       (WS-MAPSET-NAME)
                            MAPSET    (WS-MAPSET-NAME)
                            FROM      (MAILMAPO)
                            ERASE
                        END-EXEC.

       7500-SEND-OVER.

           EXEC CICS    SEND
                            MAP       (WS-MAPSET-NAME)
                            MAPSET    (WS-MAPSET-NAME)
                            FROM      (MAILMAPO)
                            CURSOR
                        END-EXEC.

       7700-SEND-CONFIRM.

           EXEC CICS    SEND
                            MAP       (WS-MAP-CONFIRM)
                            MAPSET    (WS-MAPSET-NAME)
                            MAPONLY
                        END-EXEC.

       7800-SEND-ERROR.

           EXEC CICS    SEND
                            MAP       (WS-MAP-ERROR)
                            MAPSET    (WS-MAPSET-NAME)
                            MAPONLY
                        END-EXEC.

       8000-DUMP-TASK.

           EXEC CICS DUMP DUMPCODE('ERR1')
                        END-EXEC.

       9000-RETURN-CICS.

           EXEC CICS SET TERMINAL(EIBTRMID) NOUCTRAN END-EXEC.

           EXEC CICS
                     RETURN TRANSID(EIBTRNID)
           END-EXEC.

       9999-EXIT-CICS.

           EXEC CICS SET TERMINAL(EIBTRMID) UCTRAN END-EXEC.

           MOVE +80 TO TERMINAL-MSG-LEN.
           MOVE ' TRANSACTION TERMINATED / PRESS CLEAR TO CONTINUE'
             TO TERMINAL-MSG.
           EXEC CICS
                     SEND FROM(TERMINAL-MSG) LENGTH(TERMINAL-MSG-LEN)
                          ERASE LAST
           END-EXEC.

           EXEC CICS
                     RETURN
           END-EXEC.
           GOBACK.
//LINK.SYSLIB DD
// DD
// DD
// DD
// DD DISP=SHR,DSN=SYS1.TCPIP.SEZATCP
//LINK.SYSIN DD *
  INCLUDE SYSLIB(EZACICAL)
